/*
 * Jamote - JAva MOdel-based black box TEsting (http://www.assembla.com/wiki/show/jamote)
 * Copyright (C) 2008 Jamote Team (http://www.assembla.com/spaces/jamote/team)
 * 
 *  This program is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Jamote utilizes several third-party packages whose code may
 * be distributed under a different license, see the file named LICENSE for
 * more details.
 */


public class TestExample{
	
	/**
	 * 
	 * @param a
	 * @return
	 * @throws Exception
	 */
	public int arraySumCorrect(int[] a){
		int sum = 0;
		for(int i=0;i<a.length;i++)
			sum += a[i];
		
		return sum;
	}
	
	
	/**
	 * 
	 * @param a
	 * @return
	 * @throws Exception
	 */
	public int[] arrayOrderingCorrect(int[] d){
		int[] data = d.clone();
		//insertion sort
		int tmp;
        int i, j;
        for (i = 1; i < data.length; i++) {
            tmp = data[i];
            for (j = i; j > 0 && tmp < data[j-1]; j--)
                data[j] = data[j-1];
            data[j] = tmp;
        }
        
        return data;
	}
	
	/**
	 * 
	 * @param a
	 * @return
	 * @throws Exception
	 */
	public int[] arrayOrderingWithoutDups(int[] d){
		int[] data = new int[d.length];
		//selection sort senza duplicati
		int min = Integer.MAX_VALUE;
		int lastMin = Integer.MIN_VALUE;
        int i, j, k = 0;
        for (i = 0; i < d.length; i++) {
            //trovo il minimo
            for(j = 0; j < d.length ; j++)
                if(min > d[j] && d[j] > lastMin)
                	min = d[j];
            
            if(min == Integer.MAX_VALUE)
            	data[k++] = lastMin;
            else{
            	data[k++] = min;
            	lastMin = min;
            }
            min = Integer.MAX_VALUE;
        }
        
        return data;
	}
	
	
	/**
	 * 
	 * @param a
	 * @return
	 * @throws Exception
	 */
	public int[] arrayOrderingWithoutDupsExc(int[] d) throws Exception{
		int[] data = new int[d.length];
		//selection sort senza duplicati
		int min = Integer.MAX_VALUE;
		int lastMin = Integer.MIN_VALUE;
        int i, j, k = 0;
        for (i = 0; i < d.length; i++) {
            //trovo il minimo
            for(j = 0; j < d.length ; j++)
                if(min > d[j] && d[j] > lastMin)
                	min = d[j];
            
            if(min == Integer.MAX_VALUE){
            	data[k++] = lastMin;
            	throw new Exception("Array has duplicates");
            }
            else{
            	data[k++] = min;
            	lastMin = min;
            }
            min = Integer.MAX_VALUE;
        }
        
        return data;
	}

}
