package it.dis.uniroma1.jamote;
/*
 * Jamote - JAva MOdel-based black box TEsting (http://www.assembla.com/wiki/show/jamote)
 * Copyright (C) 2008 Jamote Team (http://www.assembla.com/spaces/jamote/team)
 * 
 *  This program is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Jamote utilizes several third-party packages whose code may
 * be distributed under a different license, see the file named LICENSE for
 * more details.
 */


import java.util.ArrayList;
import java.util.List;


import it.dis.uniroma1.jamote.core.EquivalencePartition;
import it.dis.uniroma1.jamote.core.Test;
import it.dis.uniroma1.jamote.core.language.Function;
import it.dis.uniroma1.jamote.utils.ReportEntry;
import it.dis.uniroma1.jamote.utils.ReportHandler;



class ExampleHandler implements ReportHandler
{

	public void clear() {
	}

	public void handleReport(ReportEntry entry) {
		System.out.println("Level: "+ entry.getLevel() + " message: "+entry.getMessage() +
				//"\n\tclass: " + entry.getSourceClassName() +
				//"\n\tmethod: " + entry.getSourceMethodName() +
				"\n\texception: " + entry.getThrown() +
				"\n");
	}
	
}


public class Test2 {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{
		
		Test test = new Test("java", "alloy",new ExampleHandler());
		EquivalencePartition eq = new EquivalencePartition(
				//"partizione1","","all a:Input, r:Output| r.return=add[a.arg0,a.arg1]", 3,20);
				"partizione1","","one e:Exception| output.exception = e", 3,20,5);
		List<EquivalencePartition> parts = new ArrayList<EquivalencePartition>();
		parts.add(eq);
		
		List<Function> funcs = test.searchFunctions("TestExample.class");
		test.executeTest("all i:seq/Int | input.arg0.at[i] < 10",
				parts,"", funcs.get(0));
	}
}

