/*
 * Jamote - JAva MOdel-based black box TEsting (http://www.assembla.com/wiki/show/jamote)
 * Copyright (C) 2008 Jamote Team (http://www.assembla.com/spaces/jamote/team)
 * 
 *  This program is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Jamote utilizes several third-party packages whose code may
 * be distributed under a different license, see the file named LICENSE for
 * more details.
 */


package it.dis.uniroma1.jamote.core;


/**
 * 
 * Rappresenta una classe di equivalenza
 *
 */
public class EquivalencePartition {
	protected String name;
	protected String inputSpecification;
	protected String outputSpecification;
	protected int modelDimension;
	protected int maxNumberOfTests;
	protected int bitwidth;
	
	
	public EquivalencePartition(String name, String inputSpecification,
			String outputSpecification, int modelDimension, int maxNumberOfTests, int bitwidth) {
		this.name = name;
		this.inputSpecification = inputSpecification;
		this.outputSpecification = outputSpecification;
		this.maxNumberOfTests = maxNumberOfTests;
		this.modelDimension = modelDimension;
		this.bitwidth = bitwidth;
	}
	
	
	public String getName() {
		return name;
	}
	public String getInputSpecification() {
		return inputSpecification;
	}
	public String getOutputSpecification() {
		return outputSpecification;
	}
	public int getMaxNumberOfTests() {
		return maxNumberOfTests;
	}
	public int getModelDimension() {
		return modelDimension;
	}


	public int getBitwidth() {
		return bitwidth;
	}
	
}
