/*
 * Jamote - JAva MOdel-based black box TEsting (http://www.assembla.com/wiki/show/jamote)
 * Copyright (C) 2008 Jamote Team (http://www.assembla.com/spaces/jamote/team)
 * 
 *  This program is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Jamote utilizes several third-party packages whose code may
 * be distributed under a different license, see the file named LICENSE for
 * more details.
 */

package it.dis.uniroma1.jamote.core.language.java;

import java.util.List;
import it.dis.uniroma1.jamote.core.language.Function;
import it.dis.uniroma1.jamote.core.language.InterfaceParser;
import it.dis.uniroma1.jamote.core.language.JamoteLanguageException;
import it.dis.uniroma1.jamote.utils.ClassPathHacker;
import it.dis.uniroma1.jamote.utils.Reporter;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.Method;
import java.util.ArrayList;

public class JavaInterfaceParser extends InterfaceParser {

	public JavaInterfaceParser(Reporter reporter){
		super(reporter);
	}
	
	/**
	 * 
	 */
	public List<Function> parseFile(String filename) throws JamoteLanguageException{
		Method methods[]=null;
		List<Function>methodList = new ArrayList<Function>();
		File f = new File(filename);
		String className = "";
		try{
			ClassPathHacker.addFile(f.getAbsoluteFile().getParent());
			className = f.getName().split("\\.class")[0];
			Class<?> cl = Class.forName(className);
			methods = cl.getDeclaredMethods();
			
			for (int i = 0; i < methods.length; i++){
				methodList.add(new JavaFunction(methods[i]));
			}
         }
         catch (IOException ex) {
        	 throw new JamoteLanguageException("Cannot parse interface from file " +
        	 		" (maybe it doesn't exists): "+ filename,ex);   
         }
         catch (ClassNotFoundException ex) {
        	 throw new JamoteLanguageException("Cannot parse interface from " +
        	 		"specified class: " + className + " (Note: only public class and class in default" +
        	 		"package are accepted)",ex);   
         }
         
         return methodList;
	}
}
