/*
 * Jamote - JAva MOdel-based black box TEsting (http://www.assembla.com/wiki/show/jamote)
 * Copyright (C) 2008 Jamote Team (http://www.assembla.com/spaces/jamote/team)
 * 
 *  This program is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Jamote utilizes several third-party packages whose code may
 * be distributed under a different license, see the file named LICENSE for
 * more details.
 */


package it.dis.uniroma1.jamote.core.modeling;

import java.util.HashMap;
import java.util.Map;


public class InputModel 
{
	protected Map<Integer, AbstractObject> objects;

	public InputModel() {
		this.objects = new HashMap<Integer, AbstractObject>();
	}

	public Map<Integer, AbstractObject> getObjects() {
		return this.objects;
	}

	@Override
	public String toString() {
		String ret = "Arguments = {";
		for(int i = 0; i < objects.size(); i++)
		{
			ret += "arg" + i +" = {" + objects.get(new Integer(i)) + "}";
			if(objects.containsKey(new Integer(i+1)))
				ret += ", ";
		}
		
		return ret + "}";
	}

	@Override
	public boolean equals(Object obj) {
		if(! (obj instanceof InputModel))
			return false;
		
		InputModel model2 = (InputModel) obj;
		for(int i=0; i < objects.size(); i++)
			if(! model2.objects.get(new Integer(i)).equals(this.objects.get(new Integer(i))))
				return false;
		
		return  true;
	}
}
