/*
 * Jamote - JAva MOdel-based black box TEsting (http://www.assembla.com/wiki/show/jamote)
 * Copyright (C) 2008 Jamote Team (http://www.assembla.com/spaces/jamote/team)
 * 
 *  This program is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Jamote utilizes several third-party packages whose code may
 * be distributed under a different license, see the file named LICENSE for
 * more details.
 */


package it.dis.uniroma1.jamote.core.modeling;

public class OutputModel extends AbstractObject {
	protected boolean thrown;
	
	
	public OutputModel(String label, String type, Object value) {
		super(label,type,value);
		this.thrown = false;
	}


	public OutputModel(String label, String type, Object value,boolean throwed) {
		super(label,type,value);
		this.thrown = throwed;
	}

	@Override
	public String toString() {
		if(wasThrown()){
			return "Thrown Exception {"+getType()+"}";
		}
		return super.toString();
	}


	public boolean wasThrown() {
		return thrown;
	}


	@Override
	public boolean equals(Object obj) {
		if(! (obj instanceof OutputModel))
			return false;
		
		OutputModel obj2 = (OutputModel) obj;
		if(this.thrown != obj2.thrown)
			return false;
		
		return super.equals(obj);
	}
	
	
}
