/*
 * Jamote - JAva MOdel-based black box TEsting (http://www.assembla.com/wiki/show/jamote)
 * Copyright (C) 2008 Jamote Team (http://www.assembla.com/spaces/jamote/team)
 * 
 *  This program is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Jamote utilizes several third-party packages whose code may
 * be distributed under a different license, see the file named LICENSE for
 * more details.
 */


package it.dis.uniroma1.jamote.core.modeling;

import it.dis.uniroma1.jamote.core.EquivalencePartition;
import it.dis.uniroma1.jamote.utils.Reporter;
import it.dis.uniroma1.jamote.core.language.Function;

import java.util.List;


public abstract class Solver{
	private Reporter reporter;
	
	public Solver(Reporter reporter){
		this.reporter = reporter;
	}

	public Reporter getReporter() {
		return reporter;
	}
	
	/**
	 * Esegue il processo di astrazione a partire da una classe di equivalenza
	 * @param partition
	 * @return
	 */
	abstract public List<InputModel> generateModels(Function function, String defines,
			String preconditions, EquivalencePartition partition) throws JamoteModelingException;

	abstract public int checkOutput(Function function, 
			String defines, EquivalencePartition partition, InputModel m, OutputModel ret) 
			throws JamoteModelingException;
	
	abstract public OutputModel getExpectedOutput(Function function,String defines,
			EquivalencePartition partition, InputModel inputModel) 
			throws JamoteModelingException;

}
