/*
 * Jamote - JAva MOdel-based black box TEsting (http://www.assembla.com/wiki/show/jamote)
 * Copyright (C) 2008 Jamote Team (http://www.assembla.com/spaces/jamote/team)
 * 
 *  This program is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Jamote utilizes several third-party packages whose code may
 * be distributed under a different license, see the file named LICENSE for
 * more details.
 */


package it.dis.uniroma1.jamote.gui;

import java.io.File;
import java.io.IOException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;
import org.xml.sax.SAXException;

/**
 *
 * @author Oblivion
 */
public class XmlFileManager {
	
	BlackBoxTestGuiView my_gui;
	
	public XmlFileManager(BlackBoxTestGuiView gui){
		my_gui=gui;
	}
	
	public void createXmlFile(File file) {
       try {
			DocumentBuilderFactory dbfac = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = dbfac.newDocumentBuilder();
			Document doc = docBuilder.newDocument();
			Element root = doc.createElement("Jamote");
			doc.appendChild(root);
			Element childPre = doc.createElement("precondition");
			root.appendChild(childPre);
			Text textPre = doc.createTextNode(my_gui.preconditionEditorPane.getText());
			childPre.appendChild(textPre);
			Element childPost = doc.createElement("function");
			root.appendChild(childPost);
			Text textPost = doc.createTextNode(my_gui.functionEditorPane.getText());
			childPost.appendChild(textPost);
			for(int i=0;i < my_gui.equivalencePartitionInputArray.size();i++){
				Element childEq = doc.createElement("equivalence_partition");
				childEq.setAttribute("name", my_gui.equivalencePartitionNameArray.get(i));
				System.out.println("l'ho inserito "+my_gui.equivalencePartitionNameTextField.getText());
				root.appendChild(childEq);
				Element childEqIn = doc.createElement("input");
				childEq.appendChild(childEqIn);
				Text textEqIn = doc.createTextNode(my_gui.equivalencePartitionInputArray.get(i));
				childEqIn.appendChild(textEqIn);
				Element childEqOut = doc.createElement("output");
				childEq.appendChild(childEqOut);
				Text textEqOut = doc.createTextNode(my_gui.equivalencePartitionOutputArray.get(i));
				childEqOut.appendChild(textEqOut);
				Element childEqMaxModelSize = doc.createElement("max_model_size");
				childEq.appendChild(childEqMaxModelSize);
				Text textEqMaxModelSize = doc.createTextNode(my_gui.maxModelSizeArray.get(i).toString());
				childEqMaxModelSize.appendChild(textEqMaxModelSize);
				Element childEqNumTest = doc.createElement("max_number_of_test");
				childEq.appendChild(childEqNumTest);
				Text textEqNumTest = doc.createTextNode(my_gui.maxNumberOfTestArray.get(i).toString());
				childEqNumTest.appendChild(textEqNumTest);
				Element childEqBitwidth = doc.createElement("bitwidth");
				childEq.appendChild(childEqBitwidth);
				Text textEqBitwidth = doc.createTextNode(my_gui.bitwidthArray.get(i).toString());
				childEqBitwidth.appendChild(textEqBitwidth);
			}
			TransformerFactory transfac = TransformerFactory.newInstance();
			Transformer trans = transfac.newTransformer();
			trans.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
			trans.setOutputProperty(OutputKeys.INDENT, "yes");
			String filePath=file.getAbsolutePath();		
			filePath=(!(filePath.endsWith(".xml")) ? filePath.concat(".xml") : filePath);
			File xmlFile=new File(filePath);
			StreamResult result = new StreamResult(xmlFile);
			DOMSource source = new DOMSource(doc);
			trans.transform(source, result);

		} catch (DOMException e) {
			System.out.println(e);
		}catch(ParserConfigurationException e){System.out.println(e);}
		 catch(TransformerException e){System.out.println(e);}
		 catch(TransformerFactoryConfigurationError e){System.out.println(e);}	
    }

	public void loadXmlFile(File file){
			my_gui.resetGUIvalues();
			my_gui.tabbedPane.setSelectedIndex(3);
			try {
				File xmlFile = file;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				DocumentBuilder db = dbf.newDocumentBuilder();
				Document doc = db.parse(xmlFile);
				doc.getDocumentElement().normalize();
				NodeList preconditionList = doc.getElementsByTagName("precondition");
				for (int s = 0; s < preconditionList.getLength(); s++) {
					Node preconditionNode = preconditionList.item(s);
					if (preconditionNode.getNodeType() == Node.ELEMENT_NODE) {	
						Element preconditionElem = (Element) preconditionNode;
						my_gui.preconditionEditorPane.setText(preconditionElem.getTextContent());
						NodeList functionNodeList = doc.getElementsByTagName("function");
						Element functionElem = (Element) functionNodeList.item(s);
						my_gui.functionEditorPane.setText(functionElem.getTextContent());
						NodeList equivalencePartitionNodeList = doc.getElementsByTagName("equivalence_partition");
						for (int j=0;j<equivalencePartitionNodeList.getLength();j++){
							Element equivalencePartitionElem = (Element) equivalencePartitionNodeList.item(j);
							NodeList inputNodeList = equivalencePartitionElem.getElementsByTagName("input");
							Element inputElem=(Element) inputNodeList.item(0);
							NodeList outputNodeList = equivalencePartitionElem.getElementsByTagName("output");
							Element outputElem=(Element) outputNodeList.item(0);
							NodeList maxModelSizeNodeList = equivalencePartitionElem.getElementsByTagName("max_model_size");
							Element maxModelSizeElem=(Element) maxModelSizeNodeList.item(0);
							NodeList maxNumberOfTestNodeList = equivalencePartitionElem.getElementsByTagName("max_number_of_test");
							Element maxNumberOfTestElem=(Element) maxNumberOfTestNodeList.item(0);
							NodeList bitwidthNodeList = equivalencePartitionElem.getElementsByTagName("bitwidth");
							Element bitwidthElem=(Element) bitwidthNodeList.item(0);
							my_gui.equivalencePartitionList.setCellRenderer(new JTextAreaRenderer(my_gui.equivalencePartitionList));
							my_gui.equivalencePartitionList.setModel(my_gui.equivalencePartitionlistModel);
							my_gui.equivalencePartitionlistModel.addElement("------------------------------------------------------------------------\n"+"Equivalence Partition: "+ equivalencePartitionElem.getAttribute("name")+"\n"+
							("------------------------------------------------------------------------\n")+"Input:\n"+ inputElem.getTextContent()+"\n"+"output:\n"+outputElem.getTextContent()+"\n"+
									"\n"+"Max Model Size: "+ maxModelSizeElem.getTextContent()+"     Test For Model: "+maxNumberOfTestElem.getTextContent()+"      Bitwidth: "+bitwidthElem.getTextContent());

							my_gui.equivalencePartitionInputArray.add(my_gui.insertedEquivalencePartitions,inputElem.getTextContent());

							my_gui.equivalencePartitionOutputArray.add(my_gui.insertedEquivalencePartitions,outputElem.getTextContent());

							my_gui.maxModelSizeArray.add(my_gui.insertedEquivalencePartitions,Integer.parseInt(maxModelSizeElem.getTextContent()));

							my_gui.maxNumberOfTestArray.add(my_gui.insertedEquivalencePartitions,Integer.parseInt(maxNumberOfTestElem.getTextContent()));

							my_gui.bitwidthArray.add(my_gui.insertedEquivalencePartitions,Integer.parseInt(bitwidthElem.getTextContent()));
							my_gui.equivalencePartitionNameArray.add(my_gui.insertedEquivalencePartitions,equivalencePartitionElem.getAttribute("name"));
							my_gui.insertedEquivalencePartitions++;
						  }
					}
				} 
			}catch (SAXException e) {}
			catch (IOException e) {}
			catch (ParserConfigurationException e) {}
	}
}
