/*
 * Jamote - JAva MOdel-based black box TEsting (http://www.assembla.com/wiki/show/jamote)
 * Copyright (C) 2008 Jamote Team (http://www.assembla.com/spaces/jamote/team)
 * 
 *  This program is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  
 * Jamote utilizes several third-party packages whose code may
 * be distributed under a different license, see the file named LICENSE for
 * more details.
 */


package it.dis.uniroma1.jamote.utils;

/**
 * Rappresenta un messaggio di log
 *
 */
public class ReportEntry {
	public enum Level{ 
		DEBUG (1,"DEBUG"),
		VERBOSE (2,"VERBOSE"),
		DEFAULT (3,"DEFAULT"),
		WARNING (4,"WARNING"),
		ERROR (5,"ERROR");
                
        public String name;
		public int id;
		
		Level(int id,String name)
		{this.id = id;
         this.name = name;
        }
                
	}
	
	
	protected Level 	level;
	protected String 	message;
	protected String 	sourceClassName;
	protected String 	sourceMethodName;
	protected String	sourceFileName;
	protected int 		sourceLineNumber;
	protected Throwable	thrown;
	protected long		timeMillis;
	
	
	public ReportEntry(Level level, String message, String sourceClassName,
			String sourceMethodName,String sourceFileName, int lineNumber,
			Throwable thrown, long timeMillis) {
		this.level = level;
		this.message = message;
		this.sourceClassName = sourceClassName;
		this.sourceMethodName = sourceMethodName;
		this.thrown = thrown;
		this.timeMillis = timeMillis;
		this.sourceLineNumber = lineNumber;
		this.sourceFileName = sourceFileName;
	}


	public Level getLevel() {
		return level;
	}


	public String getMessage() {
		return message;
	}


	public String getSourceClassName() {
		return sourceClassName;
	}


	public String getSourceMethodName() {
		return sourceMethodName;
	}


	public Throwable getThrown() {
		return thrown;
	}


	public long getTimeMillis() {
		return timeMillis;
	}


	public int getSourceLineNumber() {
		return sourceLineNumber;
	}


	public String getSourceFileName() {
		return sourceFileName;
	}
	
	
}
